.\" Copyright (c) 1987, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	From: @(#)install.1	8.1 (Berkeley) 6/6/93
.\" $FreeBSD: src/usr.bin/xinstall/install.1,v 1.16.2.9 2002/07/01 21:01:23 des Exp $
.\" $DragonFly: src/usr.bin/xinstall/install.1,v 1.6 2007/05/17 08:19:02 swildner Exp $
.\"
.Dd May 7, 2001
.Dt INSTALL 1
.Os
.Sh NAME
.Nm install
.Nd install binaries
.Sh SYNOPSIS
.Nm
.Op Fl bCclMpSsv
.Op Fl L Ar etcdir
.Op Fl B Ar suffix
.Op Fl f Ar flags
.Op Fl g Ar group
.Op Fl m Ar mode
.Op Fl o Ar owner
.Ar file1 file2
.Nm
.Op Fl bCclMpSsv
.Op Fl L Ar etcdir
.Op Fl B Ar suffix
.Op Fl f Ar flags
.Op Fl g Ar group
.Op Fl m Ar mode
.Op Fl o Ar owner
.Ar file1 ... fileN directory
.Nm
.Fl d
.Op Fl vl
.Op Fl L Ar etcdir
.Op Fl g Ar group
.Op Fl m Ar mode
.Op Fl o Ar owner
.Ar directory ...
.Sh DESCRIPTION
The file(s) are copied
to the target file or directory.
If the destination is a directory, then the
.Ar file
is copied into
.Ar directory
with its original filename.
If the target file already exists, it is
either renamed to
.Ar file Ns Pa .old
if the
.Fl b
option is given
or overwritten
if permissions allow.
An alternate backup suffix may be specified via the
.Fl B
option's argument.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl b
Back up any existing files before overwriting them by renaming
them to
.Ar file Ns Pa .old .
See
.Fl B
for specifying a different backup suffix.
.It Fl L Ar etcdir
Specify the location of the /etc directory containing the group and password
files.  The default is "/etc".  If an alternative directory is specified
group and username lookups will be made from the alternative group and
password files rather than the system group and password files.
.It Fl B Ar suffix
Use
.Ar suffix
as the backup suffix if
.Fl b
is given.
.It Fl C
Copy the file.
If the target file already exists and the files are the same,
then don't change the modification time of the target.
.It Fl c
Copy the file.
This is actually the default.
The
.Fl c
option is only included for backwards compatibility.
.It Fl d
Create directories.
Missing parent directories are created as required.
.It Fl f
Specify the target's file flags; see
.Xr chflags 1
for a list of possible flags and their meanings.
.It Fl g
Specify a group.
A numeric GID is allowed.
.It Fl l
When the
.Fl L
option is specified and the owner or group cannot be found, fallback to
system files.
.It Fl M
Disable all use of
.Xr mmap 2 .
.It Fl m
Specify an alternate mode.
The default mode is set to rwxr-xr-x (0755).
The specified mode may be either an octal or symbolic value; see
.Xr chmod 1
for a description of possible mode values.
.It Fl o
Specify an owner.
A numeric UID is allowed.
.It Fl p
Preserve the modification time.
Copy the file, as if the
.Fl C
(compare and copy) option is specified,
except if the target file doesn't already exist or is different,
then preserve the modification time of the file.
.It Fl S
Safe copy.
Normally,
.Nm
unlinks an existing target before installing the new file.
With the
.Fl S
flag a temporary file is used and then renamed to be
the target.
The reason this is safer is that if the copy or
rename fails, the existing target is left untouched.
.It Fl s
.Nm
exec's the command
.Xr strip 1
to strip binaries so that
.Nm
can be portable over a large
number of systems and binary types.
.It Fl v
Cause
.Nm
to be verbose,
showing files as they are installed or backed up.
.El
.Pp
By default,
.Nm
preserves all file flags, with the exception of the
.Dq nodump
flag.
.Pp
The
.Nm
utility attempts to prevent moving a file onto itself.
.Pp
Installing
.Pa /dev/null
creates an empty file.
.Sh FILES
.Bl -tag -width INS@XXXX -compact
.It Pa INS@XXXX
If either
.Fl S
option is specified, or the
.Fl C
or
.Fl p
option is used in conjunction with the
.Fl s
option, temporary files named
.Pa INS@XXXX ,
where
.Pa XXXX
is decided by
.Xr mkstemp 3 ,
are created in the target directory.
.El
.Sh DIAGNOSTICS
.Ex -std
.Sh COMPATIBILITY
Historically
.Nm
moved files by default.
The default was changed to copy in
.Fx 4.4 .
.Sh SEE ALSO
.Xr chflags 1 ,
.Xr chgrp 1 ,
.Xr chmod 1 ,
.Xr cp 1 ,
.Xr mv 1 ,
.Xr strip 1 ,
.Xr mmap 2 ,
.Xr chown 8
.Sh HISTORY
The
.Nm
utility appeared in
.Bx 4.2 .
.Sh BUGS
Temporary files may be left in the target directory if
.Nm
exits abnormally.
.Pp
File flags cannot be set by
.Xr fchflags 2
over a NFS filesystem.  Other filesystems do not have a concept of flags.
The
.Nm
utility will only warn when flags could not be set on a filesystem
that does not support them.
.Pp
The
.Nm
utility with
.Fl v
falsely says a file is copied when
.Fl C
snaps hard links.
